stages:
  - prepare
  - build
  - test
  - centralize
  - deploy

# prepare
prepare:initialization:
  stage: prepare
  tags:
    - ci-auctus
    - u180464b
  script:
    - echo ci | sudo -S mv /usr/local/lib/libexpat.so.1 /usr/local/lib/libexpat.so.1.bak && echo $?;echo $?;
  allow_failure: true
  
  
# builds  
#build:release:u180464b:
#  stage: build
#  tags:
#    - ci-auctus
#    - u180464b
#  script:
#    - cd catkin_ws/
#    - source /opt/ros/kinetic/setup.bash
#    - catkin_make -j2 --force-cmake -DCMAKE_BUILD_TYPE=Release
    
build:debug:u180464b:
  stage: build
  tags:
    #- ci-auctus
    - u180464b
  script:
    - mkdir -p ci_ws/src/panda_mover
    - shopt -s extglob
    - mv !(ci_ws) ci_ws/src/panda_mover
    - cd ci_ws/src/
    - git clone https://github.com/kuka-isir/qpOASES.git
    - git clone https://oauth2:77xWF9zQnWsm6b_c1qUy@gitlab.inria.fr/auctus/panda/franka_description.git
    - git clone https://oauth2:77xWF9zQnWsm6b_c1qUy@gitlab.inria.fr/auctus/panda/panda_traj.git -b mover_changes
    - cd ..
    - catkin config --init --extend=/home/ci/soft/franka_ros_ws/devel --cmake-args -DFranka_DIR:PATH=/home/ci/soft/libfranka/build
    - source /home/ci/soft/franka_ros_ws/devel/setup.bash
    - catkin build -DCMAKE_BUILD_TYPE=Debug -DCMAKE_CXX_FLAGS=--coverage
  artifacts:
    paths:
      - ci_ws/src
      - ci_ws/build
      - ci_ws/devel  
    
# analysis
analysis:coverage:
  stage: test
  tags:
    #- ci-auctus
    - u180464b
  script:
    - mkdir -p analysis/gcov
    - source ci_ws/devel/setup.bash
    - export GAZEBO_RESOURCE_PATH=ci_ws/src/franka_description/worlds/
    - chmod +x $GAZEBO_RESOURCE_PATH/panda_world.world
    - timeout 30s roslaunch panda_mover run.launch sim:=true|| echo exit code $?
    - gcovr --filter="/home/*" --root="$PWD" --xml-pretty --object-directory="$PWD/ci_ws/build" --output="analysis/coverage.xml"
  dependencies:
    - build:debug:u180464b
  artifacts:
    paths:
      - analysis
      - ci_ws/devel
      - ci_ws/src      
  allow_failure: true
  
analysis:static:
  stage: test
  tags:
    #- ci-auctus
    - u180464b
  script:
    - mkdir analysis
    - cppcheck --enable=all --suppress=missingIncludeSystem --xml ci_ws/src/panda_mover &> analysis/cppcheckOutput.xml
    - rats --xml --warning=3 ci_ws/src > analysis/ratsOutput.xml
  dependencies:
    - build:debug:u180464b
  artifacts:
    paths:
      - analysis

sonarqube:
  stage: centralize
  dependencies:
    - analysis:coverage
    - analysis:static
  tags:
    - ci-auctus
    - u180464b
  script:
    - export PATH=$PATH:/home/ci/soft/sonar-scanner-4.2.0.1873-linux/bin
    - sonar-scanner
    
# documentation deployment
pages:
  stage: deploy
  tags:
    #- ci-auctus
    - u180464b
  script:
    - doxygen Doxyfile
    - mv html/ public/
  artifacts:
    paths:
      - public
  dependencies:
    - sonarqube
  only:
    - master


